import { world } from "@minecraft/server";
import * as gt from "@minecraft/server-gametest"

let num = 0;

const colors = ['§1', '§2', '§3', '§4', '§5', '§6', '§7', '§9', '§a', '§b', '§c', '§d', '§e', '§f', '§g', '§h', '§i']
const names = ['Felix', 'Kento', 'Domenik', 'Jesus', 'Gärner', 'Die Power in dir', 'einmal ist keinmal']

gt.registerAsync("bp", "botPlayer", async (register) => {
  const color = colors[Math.floor(Math.random() * colors.length)];
  const name = names[Math.floor(Math.random() * names.length)];
  const thePlayerName = color + name;
  thePlayerName.toString();

  let expectedPlayerJoined = false;
  const playerJoinCallback = world.afterEvents.playerJoin.subscribe(e => {
    if (e.playerName == thePlayerName) {
      expectedPlayerJoined = true;
    }
  });

  const bot = register.spawnSimulatedPlayer({ x: 0, y: 4, z: 0 }, thePlayerName);
  if (bot.chat("Hello world")) {
    register.fail(`${color}Player bot`);
  }

  await register.idle(999999998);
  if (!expectedPlayerJoined) {
    register.fail(`${color}Player bot`);
  }

  world.afterEvents.playerJoin.unsubscribe(playerJoinCallback);

  register.succeed();
}).maxTicks(999999999).structureName("botPlayer:botPlayer");

world.afterEvents.itemUse.subscribe((eventData) => {
  num += 1;
  const players = eventData.source;
  const item = eventData.itemStack;
  const player_test = world.scoreboard.getObjective("gs");
  const playerscore = world.scoreboard.getObjective("ranked");
  const getp = world.getPlayers();

  const playerScores = getp.map(p => ({
    player: p,
    score: player_test?.getScore(p),
  }));

  playerScores.sort((a, b) => (b.score ?? 0) - (a.score ?? 0));

  playerScores.forEach((ps, index) => {
    const player = ps.player;
    const score = playerscore?.getScore(player);

    // Setze den Wert von score auf 0, wenn player_test undefined ist
    if (player_test === undefined) {
      playerscore?.setScore(player, 0);
    }
    playerscore?.setScore(player, index + 1);
  });
});
