import { world, Player } from "@minecraft/server"

const allowedEntityIds = new Set([
    "ao:ao_eleven",
    "minecraft:pig"
    // Fügen Sie hier weitere Entity-IDs hinzu, falls gewünscht
])

const allowedProIds = new Set([
    "minecraft:snowball",
    "ao:glue"
])
const entityHitCounts = new Map()
world.afterEvents.projectileHitEntity.subscribe(events => {
    const source = events.source
    const entity = events.getEntityHit().entity
    const projectile = events.projectile
    if ((source instanceof Player) &&
        allowedEntityIds.has(entity.typeId) &&
        allowedProIds.has(projectile.typeId)) {
            const source_location = events.source.location
        const entity = events.getEntityHit().entity

        if (!entityHitCounts.has(entity)) {
            entityHitCounts.set(entity, 1)
        } else {
            const currentHits = entityHitCounts.get(entity)
            const newHits = currentHits + 1
            entityHitCounts.set(entity, newHits)

            if (currentHits === 2 && newHits >= 3) {
                entity.tryTeleport({ x: source_location.x, y: source_location.y, z: source_location.z })
                source.playSound("note.pling")
                entityHitCounts.delete(entity)
            }
        }
    }

})